LIKECS01 - Editorial

Problem Link

Practice

Contest

Author: Bhuvnesh Jain

Tester: Hasan Jaddouh

Editorialist: Bhuvnesh Jain

Difficulty

CAKEWALK

Prerequisites

Looping Techniques

Problem

You are given a string S and you are required to find whether there exists 2 different non-empty subsequences in S which are equal.

Quick Explanation

Check whether there exist 2 equal characters in the string.

Explanation

Lemma : If there exists a solution, then the smallest such equal subsequences will be of length 1.

Proof : Let us assume the solution exists and the length of smallest equal subsequence is greater than 1. Let the subsequences be a and b. Since they are equal, they should be of same length and each character should be same on every index. Since, the 2 subsequence should differ by atleast one index, but the subsequence being equals means that we get a smaller subsequence of length 1 which is also equal contradicting our assumption. Hence, the lemma is correct.

Now, to implement the above claim, we can simply loop over all the possible pair of positions and check if they are equal or not. The complexity of the above approach will be O(N^2), which is sufficient to pass the problem.

Actually, the above solution can be made more efficient by simply creating a frequency array of size 26 (or equivalently Alphabet size) and storing the count of every character in it. The answer exist if the frequency of any alphabet is more than 1. The complexity of this approach is O(N + ALPHABET).

Bonus problem

What is the smallest length of string required to be sure that answer will be always “yes” irrespective of the string?

Time Complexity

O(N^2) or O(N + ALPHABET), where N = length of string.

Space Complexity

O(N)

Solution Links

Setter’s solution

Tester’s solution

2 Likes

I thought this but said naah , it can’t be that easy .

1 Like

What is the smallest length of string required to be sure that answer will be always “yes” irrespective of the string?

27?

2 Likes

Can we say that the Time Complexity will never be greater than 26 i.e no of total alphabets.
thus Time Complexity O(N + Albhabet)<O(26).
As we can can but a condition that :

if(string.length()>26)
 { cout<<"yes"<<endl;
   continue;   //goes to next loop
 }

Thus, bonus Q-> min length of string required is 27 for ans to be always “yes” irrespective of any string you give as input.

1 Like

Mysolution

import java.io.;
import java.util.
;
class Codechef1
{
public static void main(String args[])
{
Scanner sc=new Scanner(System.in);
int T=sc.nextInt();
int i;
int l;
for(i=0;i<T;i++)
{
String s=sc.next();
l=s.length()-1;
int j;
HashSet hset=new HashSet();
for(j=0;j<=l;j++)
{
hset.add(s.charAt(j));
}
System.out.println(hset);
if(hset.size()==s.length())
{
System.out.println(“No”);
}
else if(hset.size()-2<s.length());
{
System.out.println(“yes”);
}
}
}
}

Happycoding

If over 200 people can solve it in the first 5 minutes, it should be easy right? :stuck_out_tongue:

Which is why the bonus question says “irrespective of the string”. In the other cases, the answer will obviously be less than 27.

i guess i am suffering from low confidence since previous long challenge .

“Because if all characters have to be distinct, then you cannot have a string of length 27 with all distinct”

That is exactly what the bonus q asks.

If you want the string to simply repeat a single character, then the smallest string required for answer to be yes would be 2. For eg: “aa”.

The two subsequences might have common elements, so in the proof of the lemma it should be the character at index i such that a_i \neq b_i, which is guaranteed to exist and is not necessarily the first.

1 Like

Damn, I messed up. I, for some reason, understood it as it as “String a has a sub sequence of String b” and was really confused. (Which is why i mentioned 2 strings in that answer, lol)

Absolutely

27 is the minimum length to guarantee the answer “yes” because of pigeon-hole principle which you may read at following link…

Ohh same here buddy!